//////////////////////////////////////////////////////////////////////////////
/// 
///  \file      VectorAsPointerExample.cpp
///  \brief     This example shows how a vector object can be treated as
///             a point to fully maximize the convenience provided by the
///             arrow operator.
/// 
///  \author    David Brownell (db@davidbrownell.com)
///  \date      09/06/2003 12:03:07 PM
/// 
///  \note
///  
///  \bug
/// 
//////////////////////////////////////////////////////////////////////////////
/// 
///  \attention
///  Copyright (c) 2003 David Brownell.  Permission to use, copy, modify,
///  distribute and sell this software and its documentation for any purpose
///  is hereby granted without fee, provided that both the previous
///  copyright notice and this permission notice appear in all copies and
///  that both the copyright notice and this permission notice appear in
///  supporting documentation.  David Brownell makes no representations
///  about the suitability of this software for any purpose.  It is provided
///  'as is' without express or implied warranty.
/// 
//////////////////////////////////////////////////////////////////////////////
#include "../ThreadSafeObject.h"
#include "Win32.h"

#include <vector>

ThreadSafeObject<std::vector<int>, TSOCriticalSection, TSOCriticalSection, ThreadSafeObjectDetails::TYPE_POINTER> g_vector;

DWORD WINAPI ThreadProc(void *)
{
    g_vector->push_back(2);
    return(0);
}

int main(void)
{
    LaunchThreads(50, ThreadProc);
    return(0);
}